//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Lamp基本マテリアルヘッダ
 * @author Junpee
 */

#ifndef LAMP_BASIC_MATERIAL_H_
#define LAMP_BASIC_MATERIAL_H_

#include <Material/System/LampMaterial.h>

namespace LampForMaya{

//------------------------------------------------------------------------------
/**
 * Lamp基本マテリアル
 */
class LampBasicMaterial : public LampMaterial{
public:
	//--------------------------------------------------------------------------
	// 静的メソッド
	//--------------------------------------------------------------------------
	/**
	 * 生成
	 *
	 * unloadPluginを行わないとメモリリークとして検出されます。
	 * @return プラグインインスタンス
	 */
	static void* creator(){ return new LampBasicMaterial(); }

	/**
	 * 初期化
	 * @return 成功すればMStatus::kSuccessを返す
	 */
	static MStatus initialize();

	/// 型識別ID
	static const MTypeId id;

	//--------------------------------------------------------------------------
	// 生成、破棄
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	LampBasicMaterial();

	/**
	 * デストラクタ
	 */
	virtual ~LampBasicMaterial();

	/**
	 * コンストラクタ前処理
	 */
	virtual void postConstructor();

	//--------------------------------------------------------------------------
	// 描画
	//--------------------------------------------------------------------------
	/**
	 * ソフトウェアレンダリング
	 * @param plug プラグ
	 * @param dataBlock データブロック
	 */
	virtual MStatus compute(const MPlug& plug, MDataBlock& dataBlock);

	//--------------------------------------------------------------------------
	/**
	 * 透明度を持つかどうか
	 */
	virtual bool hasTransparency();

	/**
	 * 頂点あたりいくつの法線を必要とするか
	 */
	virtual int normalsPerVertex();

	/**
	 * 頂点あたりいくつのカラーを必要とするか
	 */
	virtual int colorsPerVertex();

	/**
	 * 頂点あたりいくつのUVを必要とするか
	 */
	virtual int texCoordsPerVertex();

	//--------------------------------------------------------------------------
	/**
	 * 描画
	 * @return 成功すればMStatus::kSuccessを返す
	 */
	virtual MStatus glGeometry(
		const MDagPath& shapePath, int prim, u_int writable,
		int indexCount, const u_int* indexArray,
		int vertexCount, const int* vertexIDs, const float* vertexArray,
		int normalCount, const float** normalArrays,
		int colorCount, const float** colorArrays,
		int texCoordCount, const float** texCoordArrays);

	//--------------------------------------------------------------------------
	// アトリビュートアクセス
	//--------------------------------------------------------------------------
	/**
	 * ベーステクスチャの取得
	 * @return ベーステクスチャ
	 */
	virtual MObject getBaseTexture() const;

	/**
	 * ベーステクスチャ名の取得
	 * @return ベーステクスチャ名
	 */
	virtual String getBaseTextureName() const;

	/**
	 * ベースUVインデックスの取得
	 * @return ベースUVインデックス
	 */
	virtual int getBaseUVIndex() const;

	//--------------------------------------------------------------------------
	/**
	 * 光沢テクスチャの取得
	 * @return 光沢テクスチャ
	 */
	virtual MObject getGlossTexture() const;

	/**
	 * 光沢テクスチャ名の取得
	 * @return 光沢テクスチャ名
	 */
	virtual String getGlossTextureName() const;

	/**
	 * 光沢UVインデックスの取得
	 * @return 光沢UVインデックス
	 */
	virtual int getGlossUVIndex() const;

	//--------------------------------------------------------------------------
	/**
	 * ライトテクスチャの取得
	 * @return ライトテクスチャ
	 */
	virtual MObject getLightTexture() const;

	/**
	 * ライトテクスチャ名の取得
	 * @return ライトテクスチャ名
	 */
	virtual String getLightTextureName() const;

	/**
	 * ライトUVインデックスの取得
	 * @return ライトUVインデックス
	 */
	virtual int getLightUVIndex() const;

	//--------------------------------------------------------------------------
	/**
	 * 汚れテクスチャの取得
	 * @return 汚れテクスチャ
	 */
	virtual MObject getStainTexture() const;

	/**
	 * 汚れテクスチャ名の取得
	 * @return 汚れテクスチャ名
	 */
	virtual String getStainTextureName() const;

	/**
	 * 汚れUVインデックスの取得
	 * @return 汚れUVインデックス
	 */
	virtual int getStainUVIndex() const;

	//--------------------------------------------------------------------------
	/**
	 * ディフューズカラーの取得
	 * @return ディフューズカラー
	 */
	virtual Color3f getDiffuseColor() const;

	//--------------------------------------------------------------------------
	/**
	 * スペキュラカラーの取得
	 * @return スペキュラカラー
	 */
	virtual Color3f getSpecularColor() const;

	/**
	 * スペキュラパワーーの取得
	 * @return スペキュラパワー
	 */
	virtual float getSpecularPower() const;

	/**
	 * スペキュラが有効か
	 * @return スペキュラが有効ならtrue
	 */
	virtual bool isSpecularEnabled() const{
		return (getSpecularColor() != Color3f::black);
	}

	//--------------------------------------------------------------------------
	/**
	 * アンビエントカラーの取得
	 * @return アンビエントカラー
	 */
	virtual Color3f getAmbientColor() const;

	//--------------------------------------------------------------------------
	/**
	 * エミッシブカラーの取得
	 * @return エミッシブカラー
	 */
	virtual Color3f getEmissiveColor() const;

};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of LAMP_BASIC_MATERIAL_H_
//------------------------------------------------------------------------------
